aboutsummaryrefslogtreecommitdiffstats
path: root/bin/adjust_dpms
diff options
context:
space:
mode:
Diffstat (limited to 'bin/adjust_dpms')
-rwxr-xr-xbin/adjust_dpms55
1 files changed, 55 insertions, 0 deletions
diff --git a/bin/adjust_dpms b/bin/adjust_dpms
new file mode 100755
index 0000000..c8e8a0f
--- /dev/null
+++ b/bin/adjust_dpms
@@ -0,0 +1,55 @@
+#!/bin/bash
+# Script to adjust dpms settings when running certain programs,
+# that don't use fullscreen, but should not be "blanked" in between.
+# Programs are defined in separate config file ~/.config/dpms
+# Run as timed user script (i.e. adjust_dpms@.service) with systemd
+# from /etc/systemd/system/timer-minutely.target.wants
+
+export DISPLAY=:0.0
+
+config="/home/$(whoami)/.config/dpms"
+blankoff=0
+
+# check for config file existence
+if [[ -f $config ]];then
+ . /home/dave/.config/dpms
+else
+ echo "Config file not readable $config"
+ exit 1
+fi
+
+# loop all programs and check for running instances
+for i in "${programs[@]}"
+do
+ pid=$(pidof -x $i)
+ re='^[0-9]+$'
+ if [[ $pid =~ $re ]]; then
+ echo "$i running ($pid)"
+ blankoff=1
+ fi
+done
+
+# if valuable programs are running, don't use screen blanking
+if [ $blankoff -gt 0 ]; then
+ echo "Some program requires screensaver to be off."
+ # print currently set values for screensaver timeout to tmp file
+ echo "s $(xset q|grep timeout|awk '{print $2}') $(xset q|grep timeout|awk '{print $4}')" > $adjust_dpms
+ echo "dpms $(xset q|grep Standby|awk '{print $2}') $(xset q|grep Standby|awk '{print $4}') $(xset q|grep Standby|awk '{print $6}')" >> $adjust_dpms
+ # disable screensaver and dpms
+ xset s off
+ xset -dpms
+else
+ xsetq=$(xset q|grep timeout|awk '{print $2}')
+ # if the timeout is still 0, set it to its former value, or just switch on screensaver/dpms again
+ if [[ $xsetq -eq 0 ]];then
+ if [[ -f "$adjust_dpms" ]];then
+ xset $(head -n1 $adjust_dpms)
+ xset $(tail -n1 $adjust_dpms)
+ rm -rf $adjust_dpms
+ else
+ xset +dpms
+ xset s on
+ fi
+ fi
+fi
+